﻿/*
 * Created by SharpDevelop.
 * User: Josh_2
 * Date: 10/26/2013
 * Time: 5:02 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Diagnostics;
using System.Linq;
using BHComBus.Util;
using BHComBus.FGU;
using BHComBus.ArduinoComm;
using System.ComponentModel;
using System.IO.Ports;


namespace BHComBus
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form, INotifyPropertyChanged
    {

        #region INotifyPropertyChanged Implementation
        
        public event PropertyChangedEventHandler PropertyChanged;

        public void InvokePropertyChanged(PropertyChangedEventArgs e)
        {
            if (this.IsHandleCreated) // No sense in raising GUI binding updates if the GUI is not created!
            {
                try
                {
                    if (this.InvokeRequired)
                        this.Invoke(new Action(() =>
                        {
                            var handler = PropertyChanged;
                            if (handler != null) handler(this, e);
                        }));
                    else
                    {
                        var handler = PropertyChanged;
                        if (handler != null) handler(this, e);
                    }
                }
                catch (Exception ex)
                {

                }
            }
            
        }

        public void InvokePropertyChanged(string property)
        {
            InvokePropertyChanged(new PropertyChangedEventArgs(property));
        }
        
        #endregion

        public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
            setupDataStore();
            initAdHocExperiment(16);
            initFG();
            initArduinoConfig();
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//

            ArduinoStatusTextbox.DataBindings.Add("Text", this, "CurrentArduinoDeviceStatus");
            ASArduinoStatusTextbox.DataBindings.Add("Text", this, "CurrentArduinoDeviceStatus");
		}

        private void label1_Click(object sender, EventArgs e)
        {

        }


        


        private void FGStartButton_MouseClick(object sender, MouseEventArgs e)
        {

        }

        
        private void openFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
        {
            
        }

        private void ASSerialGroupBox_Enter(object sender, EventArgs e)
        {

        }

        private void SendCommandButton_Click(object sender, EventArgs e)
        {
            
        }

        private void CommandsGridView_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void button5_Click(object sender, EventArgs e)
        {
            var cd = ArduinoNanoDeviceInterface.currentDevice;
            cd.OnReceiveSerialData -= currentDevice_OnReceiveSerialData;
            cd.OnSerialPortWrite -= currentDevice_OnSerialPortWrite;
            cd.OnReceiveMessage -= currentDevice_OnReceiveMessage;
            cd.OnReceiveErrorMessage += currentDevice_OnReceiveErrorMessage;
            cd.OnReceiveDebugMessage -= currentDevice_OnReceiveDebugMessage;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            var cd = ArduinoNanoDeviceInterface.currentDevice;
            cd.OnReceiveSerialData += currentDevice_OnReceiveSerialData;
            cd.OnSerialPortWrite += currentDevice_OnSerialPortWrite;
            cd.OnReceiveMessage += currentDevice_OnReceiveMessage;
            cd.OnReceiveErrorMessage += currentDevice_OnReceiveErrorMessage;
            cd.OnReceiveDebugMessage += currentDevice_OnReceiveDebugMessage;
        }
       
        private void frequencyLabel_Click(object sender, EventArgs e)
        {

        }

        private void DataFolderTextbox_TextChanged(object sender, EventArgs e)
        {

        }


        
        



    }
}
