﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Diagnostics;
using System.Linq;
using BHComBus.Util;
using BHComBus.FGU;
using BHComBus.ArduinoComm;
using BHComBus.Data;
using System.ComponentModel;
using System.Threading;
using BHComBus.Device;

namespace BHComBus
{
    /// <summary>
    /// Description of MainForm.
    /// </summary>
    public partial class MainForm
    {
        private PicoscopeDeviceManager scope;
        
        public static string CurrentPicoscopeDeviceStatus;
        private void PicoScopeReconnectButton_Click(object sender, EventArgs e)
        {
            PicoscopeDeviceManager.scopeready = false;
            scope = PicoscopeDeviceManager.GetDeviceManager();
            while (PicoscopeDeviceManager.scopeready == false) ;
            CurrentPicoscopeDeviceStatus = PicoscopeStatusToString(scope.OscilloscopeStatus);
            PicoscopeStatusTextbox.Text = CurrentPicoscopeDeviceStatus;
        }
        private void PicoscopeStatusTextbox_TextChanged(object sender, EventArgs e)
        {
            CurrentPicoscopeDeviceStatus = PicoscopeStatusToString(scope.OscilloscopeStatus);
            PicoscopeStatusTextbox.Text = CurrentPicoscopeDeviceStatus;
        }

        private string PicoscopeStatusToString(DeviceStatus status)
        {
            switch (status) {
                case DeviceStatus.NOT_CONNECTED: return "NOT CONNECTED";
                case DeviceStatus.READY: return "READY";
                case DeviceStatus.BUSY: return "BUSY";
                case DeviceStatus.ERROR: return "ERROR";
                default: return "";
            }
        }
    }
}