﻿
using System.Runtime.InteropServices;
using System.Threading.Tasks;

namespace BHComBus.FGU
{

    public enum Function : int
    {
        sine = 1,
        square = 2,
        triangle = 3
    }

    public enum Filter : int
    {
        lowPassOn = 1,
        lowPassOff = 0
    }

    public enum GenStatus : int
    {
        LoadingSettings = 0,
        OK = 1,
        USBConnectionFailed = -1,
        PowerAdaptorDisconnected = -2
    }

    public static class FGUImports
    {        
        private const string _DLL_FILE = "FGULink.dll";
        private const string _CONTROL_PROG = "FGU.exe";


      [DllImport(_DLL_FILE, EntryPoint = "OpenGen")]
      public static extern void OpenGen();

      [DllImport(_DLL_FILE, EntryPoint = "CloseGen")]
      public static extern void CloseGen();

      [DllImport(_DLL_FILE, EntryPoint = "StartGen")]
      public static extern void StartGen();

      [DllImport(_DLL_FILE, EntryPoint = "StopGen")]
      public static extern void StopGen();

      [DllImport(_DLL_FILE, EntryPoint = "GenReady")]
      public static extern bool GenReady();

      [DllImport(_DLL_FILE, EntryPoint = "GenStatus")]
      public static extern GenStatus GenStatus();

      [DllImport(_DLL_FILE, EntryPoint = "SetGen")]
      public static extern void SetGen(Function func, float freqHz, float amplP2PV, float offsetVDC);

      [DllImport(_DLL_FILE, EntryPoint = "SetSweep")]
      public static extern void SetSweep(float freqHz1, float freqHz2, float amplP2PV, float offsetVDC, float sweepTimeInSecs, int form);

      [DllImport(_DLL_FILE, EntryPoint = "SetLibWave")]
      public static extern void SetLibWave(float freqHz, float amplP2PV, float offsetVDC, Filter filter, string fileName);

      [DllImport(_DLL_FILE, EntryPoint = "ShowGen")]
      public static extern void ShowGen(bool status);

      [DllImport(_DLL_FILE, EntryPoint = "AttOn")]
      public static extern void AttOn(bool att);

      [DllImport(_DLL_FILE, EntryPoint = "LogSweep")]
      public static extern void LogSweep(bool log);
    }

    

    public static class FGUController
    {

    }
}
