﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BHComBus.Data;

namespace BHProbeLib
{
    public class ProbeTipConfiguation
    {
        //MUX (in, out) addresses in order from lowest to highest horizontal pairs
        public List<ElectrodePair> horizontalElectrodePairOrder
        {
            get;
            private set;
        }

        private ProbeTipConfiguation(List<ElectrodePair> horizontalPairs) { 
            horizontalElectrodePairOrder = horizontalPairs;
        }


        public static ProbeTipConfiguation linearConfiguration()
        {
            var hPairs = new List<ElectrodePair>(8);
            //MUX (in, out) addresses in order from lowest to highest horizontal pairs
            hPairs.Add(new ElectrodePair(8, 8));
            hPairs.Add(new ElectrodePair(9, 9));
            hPairs.Add(new ElectrodePair(10, 10));
            hPairs.Add(new ElectrodePair(11, 11));
            hPairs.Add(new ElectrodePair(12, 12));
            hPairs.Add(new ElectrodePair(13, 13));
            hPairs.Add(new ElectrodePair(14, 14));
            hPairs.Add(new ElectrodePair(15, 15));

            var config = new ProbeTipConfiguation(hPairs);
            
            
            return config;
        }

        public static ProbeTipConfiguation helicalConfiguration()
        {
            var hPairs = new List<ElectrodePair>(8);
            //MUX (in, out) addresses in order from lowest to highest horizontal pairs
            /* hPairs.Add(new ElectrodePair(8, 15));
             hPairs.Add(new ElectrodePair(9, 14));
             hPairs.Add(new ElectrodePair(10, 13));
             hPairs.Add(new ElectrodePair(11, 12));
             hPairs.Add(new ElectrodePair(12, 11));
             hPairs.Add(new ElectrodePair(13, 10));
             hPairs.Add(new ElectrodePair(14, 9));
             hPairs.Add(new ElectrodePair(15, 8));*/
            hPairs.Add(new ElectrodePair(9, 14));
               hPairs.Add(new ElectrodePair(8, 15));
               hPairs.Add(new ElectrodePair(11, 12));
               hPairs.Add(new ElectrodePair(10, 13));
               hPairs.Add(new ElectrodePair(13, 10));
               hPairs.Add(new ElectrodePair(12, 11));
               hPairs.Add(new ElectrodePair(15, 8));
               hPairs.Add(new ElectrodePair(14, 9));

            var config = new ProbeTipConfiguation(hPairs);

            return config;
        }
    }
}